﻿using System;
using Microsoft.SqlServer.Management.Smo;
using System.Data;

namespace IntroToSmo
{
    public partial class Program3 : System.Web.UI.Page
    {
        /// <summary>
        /// 
        /// This program illustrates how to connect to an SQL Instance and use SMO to retreive a list of 
        /// users for a specific database
        /// 
        /// </summary>
        
        protected void Page_Load(object sender, EventArgs e)
        {
            // connect to the default instance on the named server
            Server myServer = new Server("SQL2012SERVER");                               // Change to your server name
            myServer.ConnectionContext.ConnectAsUser = true;
            myServer.ConnectionContext.ConnectAsUserName = "myusername@mydomainname";   // change to your user name@domain
            myServer.ConnectionContext.ConnectAsUserPassword = "myPassword";            // change to your password
            myServer.ConnectionContext.Connect();

            // create the datatable to be used as a data source for the GridView
            DataTable myUserList = new DataTable();
            myUserList.Columns.Add("UserName", typeof(string));

            // get the list of users for the specific named database
            UserCollection myUsersList = myServer.Databases["MyInstantHelpdesk_Development"].Users;
            
            // fill in the datatable with the user name 
            foreach (Microsoft.SqlServer.Management.Smo.User myUser in myUsersList)
            {
                myUserList.Rows.Add(myUser.Name);
            }

            // bind it to the GridView ready for the web form to present it
            GridView1.DataSource = myUserList;
            GridView1.DataBind();
        }
    }
}