﻿using System;
using Microsoft.SqlServer.Management.Smo;
using System.Data;
using System.Collections.Specialized;

namespace IntroToSmo
{
    public partial class Program4 : System.Web.UI.Page
    {
        /// <summary>
        /// 
        /// This program illustrates how to connect to an SQL Instance and use SMO to retreive a list of 
        /// roles against a specific users and database
        /// 
        /// </summary>
        
        protected void Page_Load(object sender, EventArgs e)
        {
            // connect to the default instance on the named server
            Server myServer = new Server("SQL2012SERVER");                               // Change to your server name
            myServer.ConnectionContext.ConnectAsUser = true;
            myServer.ConnectionContext.ConnectAsUserName = "myusername@mydomainname";   // change to your user name@domain
            myServer.ConnectionContext.ConnectAsUserPassword = "myPassword";            // change to your password
            myServer.ConnectionContext.Connect();

            // create the datatable to be used as a data source for the GridView
            DataTable myUserList = new DataTable();
            myUserList.Columns.Add("RoleName", typeof(string));

            // Gets the list of users for the database
            UserCollection myUsersList = myServer.Databases["MyInstantHelpdesk_Development"].Users;

            // gets the roles for a specific user
            StringCollection myRoleList = myUsersList["myinstanthelpdesk"].EnumRoles();

            // fill in the datatable with the roles the user belongs too
            foreach (String myRole in myRoleList)
            {
                myUserList.Rows.Add(myRole);
            }

            // bind it to the GridView ready for the web form to present it
            GridView1.DataSource = myUserList;
            GridView1.DataBind();

        }
    }
}